% Compile libraries and download network

[home_dir, name, ext] = fileparts(mfilename('fullpath'));

warning('ON', 'CFCF:install')

% mtimesx
if exist('external_libs/mtimesx', 'dir') == 7
    cd external_libs/mtimesx
    mtimesx_build;
    cd(home_dir)
else
    error('CFCF:install', 'Mtimesx not found.')
end

% PDollar toolbox
if exist('external_libs/pdollar_toolbox/external', 'dir') == 7
    cd external_libs/pdollar_toolbox/external
    toolboxCompile;
    cd(home_dir)
else
    warning('CFCF:install', 'PDollars toolbox not found. Clone this submodule if you want to use HOG features. Skipping for now.')
end

% matconvnet
if exist('external_libs/matconvnet/matlab', 'dir') == 7
    cd external_libs/matconvnet/matlab
    vl_compilenn;
    status = movefile('mex/vl_*.mex*');
    cd(home_dir)
    
    % donwload network
    cd feature_extraction
    mkdir networks
    cd networks
    cd(home_dir)
else
    warning('CFCF:install', 'Matconvnet not found. Clone this submodule if you want to use CNN features. Skipping for now.')
end

% Required for the feature extraction part without the GPU support
s1 = unix('rm feature_extraction/get_cnn_layers.m');
s2 = unix('rm feature_extraction/load_cnn.m');
s3 = unix('mv feature_extraction/get_cnn_layers_CPU.m feature_extraction/get_cnn_layers.m');
s4 = unix('mv feature_extraction/load_cnn_CPU.m feature_extraction/load_cnn.m');

s5 = unix('sed -i ''s/get_cnn_layers_CPU/get_cnn_layers/g'' feature_extraction/get_cnn_layers.m');
s6 = unix('sed -i ''s/load_cnn_CPU/load_cnn/g'' feature_extraction/load_cnn.m');